// -------------------------------------------------------------------------
// OS/2 DOOM Audio Mixer Library. (C) 2001 Dmitry Zaharov, Russian Team OS/2
// -------------------------------------------------------------------------

// -------------------------------------------------------------------------
// NOTE:You can use this library for your own purposes, but you must include
//      our link or copyright reference in your program information or text.
// -------------------------------------------------------------------------

#define INCL_DOS
#include <stdio.h>
#include <stdlib.h>
#include "windows.h"	// So, get a socks?


extern HWND	    hClient;
int		    cur_buffer = 0;
int		    sample_inc,prebufsize;
USHORT		    usDeviceID = 0;
MCI_BUFFER_PARMS    buffer_parms;
MCI_AMP_OPEN_PARMS  amp_open_parms;

// some tables...

//char volume_table[64][256]; // UNUSED. We use 16 bit for both 8&16 mixers
short volume_table16[64][256];
short *prebuffer;

// channels

#define CHANNELS 32
#define MAXMIDIHANDLES 60 // well, it is enough, i think

typedef struct _MIX_CHANNEL_STRUC {
unsigned char *sample;
unsigned sample_rate;
unsigned vol, pan;
unsigned sample_pos, sample_size;
} MIX_CHANNEL_STRUC;

MIX_CHANNEL_STRUC mix_channel[CHANNELS];
MCI_MIXSETUP_PARMS mix_setup_parms;
MCI_MIX_BUFFER my_buffers[4];


typedef struct _MIDI_HANDLE_RECORD {
char *midimem;
short reserverd;
short usDeviceID;
int   loop;
ULONG hmmio;
} MIDI_HANDLE_RECORD;

MIDI_HANDLE_RECORD midi_handles[MAXMIDIHANDLES];

// ==========================================================================
// Stereo Mixers

// --------------------------------------------------------------------------
// 16-bit

void process_mixer16s(short *buf, ULONG n)
{
unsigned long i, j, todo, step, s_add, s_end, x;
char *s,*p;
short *t,*rv,*lv;
memset((char*)prebuffer, '\0', n);
for(i=0; i<CHANNELS; i++)
{
if(!mix_channel[i].sample) continue;
if(!mix_channel[i].sample_rate) continue;
if(!mix_channel[i].sample_size) continue;

s_add = (sample_inc*mix_channel[i].sample_rate) / mix_setup_parms.ulSamplesPerSec;

if(mix_channel[i].vol>0)
{
s_end = mix_channel[i].sample_size-mix_channel[i].sample_pos;

//if(s_end<0)s_end = s_add;
step = (mix_channel[i].sample_rate<<16) / mix_setup_parms.ulSamplesPerSec;
s_end <<= 16; s_end /= step;

lv = &volume_table16[(mix_channel[i].vol*(mix_channel[i].pan^255))>>8][0];
rv = &volume_table16[(mix_channel[i].vol*mix_channel[i].pan)>>8][0];

s = (char*)mix_channel[i].sample;
s += mix_channel[i].sample_pos;
x = 0;
t = prebuffer;

todo = ((n/4) < s_end) ? (n/4) : s_end;

for(j=0;j<todo;j++)
{
p = &s[x>>16];
*t += (short)lv[(unsigned char)*p]; t++;
*t += (short)rv[(unsigned char)*p]; t++;
x += step;
}
}

mix_channel[i].sample_pos += s_add;
if(mix_channel[i].sample_pos >= mix_channel[i].sample_size)
{
mix_channel[i].sample = (char*)NULL; // kick channel
mix_channel[i].sample_rate = 0;	     // kick channel
mix_channel[i].sample_size = 0;	     // kick channel
}

}

t = prebuffer;

// write prebuffer

//for(i=0;i<prebufsize;i++)
//{
//*buf = (*t >> 5) ^ 128; buf++; t++;
//}
memcpy((char*)buf, (char*)t, n);

}

// --------------------------------------------------------------------------
// 8-bit

void process_mixer8s(char *buf, ULONG n)
{
unsigned int i, j, todo, step, s_add, s_end, x;
char *s,*p;
short *t,*rv,*lv;
memset((char*)prebuffer, '\0', n*2);
for(i=0; i<CHANNELS; i++)
{
if(!mix_channel[i].sample) continue;
if(!mix_channel[i].sample_rate) continue;
if(!mix_channel[i].sample_size) continue;

s_add = (sample_inc*mix_channel[i].sample_rate) / mix_setup_parms.ulSamplesPerSec;

if(mix_channel[i].vol>0)
{
s_end = mix_channel[i].sample_size-mix_channel[i].sample_pos;

//if(s_end<0)s_end = s_add;
step = (mix_channel[i].sample_rate<<16) / mix_setup_parms.ulSamplesPerSec;
s_end <<= 16; s_end /= step;

lv = &volume_table16[(mix_channel[i].vol*(mix_channel[i].pan^255))>>8][0];
rv = &volume_table16[(mix_channel[i].vol*mix_channel[i].pan)>>8][0];

s = (char*)mix_channel[i].sample;
s += mix_channel[i].sample_pos;
x = 0;
t = prebuffer;

todo = ((n/2) < s_end) ? (n/2) : s_end;

while(todo--)
{
p = &s[x>>16];
*t += (short)lv[(unsigned char)*p]; t++;
*t += (short)rv[(unsigned char)*p]; t++;
//*t += (j & 31)<<5;
x += step;
}
}

mix_channel[i].sample_pos += s_add;
if(mix_channel[i].sample_pos >= mix_channel[i].sample_size)
{
mix_channel[i].sample = (char*)NULL; // kick channel
mix_channel[i].sample_rate = 0;	     // kick channel
mix_channel[i].sample_size = 0;	     // kick channel
}

}

t = prebuffer;

// write prebuffer

for(i=0;i<n;i++)
{
*buf = (*t >> 8) ^ 128; buf++; t++;
}

}

// ==========================================================================
// Mono Mixers

// --------------------------------------------------------------------------
// 16-bit

void process_mixer16m(short *buf, ULONG n)
{
unsigned int i, j, todo, step, s_add, s_end, x;
char *s;
short *t,*v;
memset((char*)prebuffer, '\0', n);
for(i=0; i<CHANNELS; i++)
{
if(!mix_channel[i].sample) continue;
if(!mix_channel[i].sample_rate) continue;
if(!mix_channel[i].sample_size) continue;

s_add = (sample_inc*mix_channel[i].sample_rate) / mix_setup_parms.ulSamplesPerSec;

if(mix_channel[i].vol>0)
{
s_end = mix_channel[i].sample_size-mix_channel[i].sample_pos;

//if(s_end<0)s_end = s_add;
step = (mix_channel[i].sample_rate<<16) / mix_setup_parms.ulSamplesPerSec;
s_end <<= 16; s_end /= step;

v = &volume_table16[mix_channel[i].vol][0];

s = (char*)mix_channel[i].sample;
s += mix_channel[i].sample_pos;
x = 0;
t = prebuffer;

todo = ((n/2) < s_end) ? (n/2) : s_end;

while(todo--)
{
*t += (short)v[(unsigned char)s[x>>16]]; t++;
x += step;
}
}

mix_channel[i].sample_pos += s_add;
if(mix_channel[i].sample_pos >= mix_channel[i].sample_size)
{
mix_channel[i].sample = (char*)NULL; // kick channel
mix_channel[i].sample_rate = 0;	     // kick channel
mix_channel[i].sample_size = 0;	     // kick channel
}

}

t = prebuffer;

// write prebuffer

//for(i=0;i<prebufsize;i++)
//{
//*buf = (*t >> 5) ^ 128; buf++; t++;
//}
memcpy((char*)buf, (char*)t, n);

}

// --------------------------------------------------------------------------
// 8-bit

void process_mixer8m(char *buf, ULONG n)
{
unsigned int i, j, todo, step, s_add, s_end, x;
char *s,*p;
short *t,*v;
memset((char*)prebuffer, '\0', n*2);
for(i=0; i<CHANNELS; i++)
{
if(!mix_channel[i].sample) continue;
if(!mix_channel[i].sample_rate) continue;
if(!mix_channel[i].sample_size) continue;

s_add = (sample_inc*mix_channel[i].sample_rate) / mix_setup_parms.ulSamplesPerSec;

if(mix_channel[i].vol>0)
{
s_end = mix_channel[i].sample_size-mix_channel[i].sample_pos;

//if(s_end<0)s_end = s_add;
step = (mix_channel[i].sample_rate<<16) / mix_setup_parms.ulSamplesPerSec;
s_end <<= 16; s_end /= step;

v = &volume_table16[mix_channel[i].vol][0];

s = (char*)mix_channel[i].sample;
s += mix_channel[i].sample_pos;
x = 0;
t = prebuffer;

todo = n < s_end ? n : s_end;

//fprintf(stderr,"s_add: %d\n",s_add);

while(todo--)
{
*t += (short)v[(unsigned char)s[x>>16]];
t++;
x += step;
}
}

mix_channel[i].sample_pos += s_add;
if(mix_channel[i].sample_pos >= mix_channel[i].sample_size)
{
mix_channel[i].sample = (char*)NULL; // kick channel
mix_channel[i].sample_rate = 0;	     // kick channel
mix_channel[i].sample_size = 0;	     // kick channel
}

}

t = prebuffer;

// write prebuffer

for(i=0;i<n;i++)
{
*buf = (*t >> 8) ^ 128; buf++; t++;
}

}

LONG APIENTRY my_event_proc ( ULONG ulStatus, PMCI_MIX_BUFFER  pBuffer,
                              ULONG ulFlags )

{
   switch( ulFlags )
   {
   case MIX_STREAM_ERROR | MIX_WRITE_COMPLETE:  /* error occur in device */

      break;

   case MIX_WRITE_COMPLETE:           /* for playback  */

   mix_setup_parms.pmixWrite( mix_setup_parms.ulMixHandle,
                              &my_buffers[cur_buffer], // old buffer
                              1 );

   cur_buffer ^= 1;

   if( mix_setup_parms.ulChannels > 1)
   {

   if( mix_setup_parms.ulBitsPerSample == 16)
   {
   process_mixer16s( (short*)my_buffers[cur_buffer].pBuffer,
                     my_buffers[cur_buffer].ulBufferLength );
   }
   else
   {
   process_mixer8s( (char*)my_buffers[cur_buffer].pBuffer,
		    my_buffers[cur_buffer].ulBufferLength );
   }

   } else {

   if( mix_setup_parms.ulBitsPerSample == 16)
   {
   process_mixer16m( (short*)my_buffers[cur_buffer].pBuffer,
                     my_buffers[cur_buffer].ulBufferLength );
   }
   else
   {
   process_mixer8m( (char*)my_buffers[cur_buffer].pBuffer,
		    my_buffers[cur_buffer].ulBufferLength );
   }
   }

   break;
   } /* end switch */

   return( TRUE );
}

// Library exported funcs

int audio_startup(int samplerate, int bits, int stereo, int bufsize)
{
ULONG rc;
int i,j;

memset ( &amp_open_parms, '\0', sizeof ( MCI_AMP_OPEN_PARMS ) );
amp_open_parms.usDeviceID = ( USHORT ) 0;
amp_open_parms.pszDeviceType = ( PSZ ) MCI_DEVTYPE_AUDIO_AMPMIX;

rc = mciSendCommand( 0,
                     MCI_OPEN,
                     MCI_WAIT | MCI_OPEN_TYPE_ID | MCI_OPEN_SHAREABLE,
                     ( PVOID ) &amp_open_parms,
                     0 );

if ( rc != MCIERR_SUCCESS )
{
fprintf(stderr,"Error opening AMP. rc = %d\n", rc);
return 0;
}

usDeviceID = amp_open_parms.usDeviceID;
 
memset( &mix_setup_parms, '\0', sizeof( MCI_MIXSETUP_PARMS ) );

mix_setup_parms.ulBitsPerSample = bits;
mix_setup_parms.ulFormatTag     = MCI_WAVE_FORMAT_PCM;
mix_setup_parms.ulSamplesPerSec = samplerate;
mix_setup_parms.ulChannels      = stereo ? 2L : 1L;    /* Stereo */
mix_setup_parms.ulFormatMode    = MCI_PLAY;
mix_setup_parms.ulDeviceType    = MCI_DEVTYPE_WAVEFORM_AUDIO;
mix_setup_parms.pmixEvent       = my_event_proc;
 
rc = mciSendCommand( usDeviceID,
                     MCI_MIXSETUP,
                     MCI_WAIT | MCI_MIXSETUP_INIT,
                     ( PVOID ) &mix_setup_parms,
                     0 );

if ( rc != MCIERR_SUCCESS )
   {
   fprintf(stderr,"Error opening audio device %s\n");
   return 0;
   }


// allocating DART buffers

memset( &buffer_parms, '\0', sizeof( MCI_BUFFER_PARMS ) );

//bufsize = mix_setup_parms.ulBufferSize;

 
buffer_parms.ulNumBuffers = 3; // base and secondary buffer (buffer switch trick)
buffer_parms.ulBufferSize = bufsize;
buffer_parms.pBufList = my_buffers;

rc = mciSendCommand( usDeviceID,
                     MCI_BUFFER,
                     MCI_WAIT | MCI_ALLOCATE_MEMORY,
                     ( PVOID ) &buffer_parms,
                     0 );
  
if ( ULONG_LOWD( rc) != MCIERR_SUCCESS )
   {
   fprintf( stderr,"Error allocating buffers memory.  rc is : %d\n", rc );
   return 0;
   }
  
//my_buffers[1].ulUserParm = 1UL;

fprintf(stderr,"audio setup - %dHz, %dbit, %s (Buffer size is %d) - ok\n",
	        samplerate,bits,stereo ? "stereo" : "mono",
                buffer_parms.ulBufferSize);

// setting up lookup tables

for(i=0; i<64; i++)
for(j=0; j<256; j++)
    {
//    volume_table[i][j] = (char)((i*(j-128))/63);
    volume_table16[i][j] = (short)(i*(j-128));
    }

// allocating pre-buffer base mixer

if(bits == 16) memset(my_buffers[0].pBuffer, '\0', bufsize);
else           memset(my_buffers[0].pBuffer, 128, bufsize);

if(bits == 16) memset(my_buffers[1].pBuffer, '\0', bufsize);
else           memset(my_buffers[1].pBuffer, 128, bufsize);

if(bits == 16) memset(my_buffers[2].pBuffer, '\0', bufsize);
else           memset(my_buffers[2].pBuffer, 128, bufsize);


my_buffers[0].ulBufferLength = bufsize;
my_buffers[1].ulBufferLength = bufsize;
//my_buffers[2].ulBufferLength = bufsize;

if(bits == 16) sample_inc = bufsize/(2*mix_setup_parms.ulChannels);
else	       sample_inc = bufsize/mix_setup_parms.ulChannels;

// pre-mix 16bit buffer

prebufsize = ((bits==16) ? (bufsize/2) : bufsize);

prebuffer = (short*)malloc( prebufsize*sizeof(short) );

memset((char*)&mix_channel[0], '\0', CHANNELS*sizeof(MIX_CHANNEL_STRUC));

for(i=0;i<CHANNELS;i++)
{
mix_channel[i].sample = (char*)NULL; // kick channel
mix_channel[i].sample_rate = 0;	     // kick channel
mix_channel[i].sample_size = 0;	     // kick channel
mix_channel[i].sample_pos = 0;	     // kick channel
}

mix_setup_parms.pmixWrite( mix_setup_parms.ulMixHandle,
                           my_buffers, // old buffer
                           3 );

//cur_buffer = 1 - cur_buffer;

return 1; // success
} 

void audio_setvolume(int volume)
{
MCI_AMP_SET_PARMS AmpSetParms;
ULONG rc;
memset( &AmpSetParms, '\0', sizeof( MCI_AMP_SET_PARMS ) );
AmpSetParms.ulAudio = MCI_SET_AUDIO_ALL;
AmpSetParms.ulItem = 0;
AmpSetParms.ulLevel = (volume*100)/15;
rc = mciSendCommand( usDeviceID,
                     MCI_SET,
                     MCI_WAIT | MCI_SET_AUDIO | MCI_SET_VOLUME,
                     ( PVOID ) &AmpSetParms,
                     0 );
}

void audio_close()
{
MCI_GENERIC_PARMS    GenericParms;
ULONG                rc;

free( prebuffer );

rc = mciSendCommand( usDeviceID,
                     MCI_BUFFER,
                     MCI_WAIT | MCI_DEALLOCATE_MEMORY,
                     ( PVOID )&buffer_parms,
                     0 );

if ( rc != MCIERR_SUCCESS )
{
return;
}

rc = mciSendCommand( usDeviceID,
                     MCI_STOP,
                     MCI_WAIT,
                     ( PVOID )&GenericParms,
                     0 );

rc = mciSendCommand( usDeviceID,
                     MCI_CLOSE,
                     MCI_WAIT ,
                     ( PVOID )&GenericParms,
                     0 );
free(prebuffer);
}

void audio_channel_parms(int i, unsigned vol, unsigned pan)
{
if(i>=CHANNELS) return;
if(!mix_channel[i].sample) return;
if(!mix_channel[i].sample_rate) return;
if(!mix_channel[i].sample_size) return;

mix_channel[i].vol = vol>>2;
mix_channel[i].pan = pan;
}

void audio_stop_channel(int i)
{
if(i>=CHANNELS) return;
if(!mix_channel[i].sample) return;
if(!mix_channel[i].sample_rate) return;
if(!mix_channel[i].sample_size) return;

mix_channel[i].sample = (char*)NULL; // kick channel
mix_channel[i].sample_rate = 0;	     // kick channel
mix_channel[i].sample_size = 0;	     // kick channel
mix_channel[i].sample_pos = 0;	     // kick channel
}

int audio_channel_playing(int i)
{
if(i>=CHANNELS) return 0;
if(!mix_channel[i].sample) return 0;
else			   return 1;
}

int audio_play_sample(char *sampledata, unsigned sample_rate,
	              unsigned sample_size, unsigned vol, unsigned pan)
{
int i,j=0;
for(i=0;i<CHANNELS;i++) // search for free channel?
{
if(!mix_channel[i].sample)break;
if(mix_channel[i].sample_pos>mix_channel[j].sample_pos)
   j=i;
}

if(i==CHANNELS) i=j; // no free channel, use "oldest"

//fprintf(stderr,"Play sample [%ld] (%d-%d) for %d\n",(ULONG)sampledata,sample_rate,
//	sample_size,i);

mix_channel[i].sample = sampledata;
mix_channel[i].sample_rate = sample_rate;
mix_channel[i].sample_size = sample_size;
mix_channel[i].sample_pos = 0;
mix_channel[i].vol = vol>>2;
mix_channel[i].pan = pan; // it is stereo. (i think?)

return i;
}

int midi_startup()
{
int i;
for(i=0;i<MAXMIDIHANDLES;i++)
{
midi_handles[i].midimem = (char*)NULL;
midi_handles[i].usDeviceID = 0;
midi_handles[i].loop = 0;
}
return 1;
}

int midi_register(char *midimem,int bufsize)
{
/* variable for IOProc */
int i;
/* variables for memory file */
MMIOINFO  mmioInfo;
HMMIO     hmmio;
ULONG rc;
/* variables for MCI commands */
MCI_OPEN_PARMS  mop;

for(i=0;i<MAXMIDIHANDLES;i++) // search for free channel?
{
if(!midi_handles[i].midimem)break;
}

if(i==MAXMIDIHANDLES)return -1;
 
/* Open memory file. Provide MIDI-filled data buffer to MMIO, so
 * data buffer becomes file image in memory.  Also specify that
 * the data will need to be translated.
 */

//fprintf(stderr,"Registering midi: size %d\n",bufsize);

memset((void*)&mmioInfo, '\0', sizeof(MMIOINFO));
memset((void*)&mop, '\0', sizeof(MCI_OPEN_PARMS));
 
mmioInfo.pchBuffer = midimem; /* Filled with untranslated MIDI data                */
mmioInfo.cchBuffer = bufsize; /* User-defined         */
mmioInfo.ulTranslate = MMIO_TRANSLATEDATA | MMIO_TRANSLATEHEADER;
                       /* Need to translate data    */
mmioInfo.fccIOProc = mmioFOURCC( 'M', 'I', 'D', 'I');/* Data
                                                          format */
mmioInfo.fccChildIOProc = FOURCC_MEM;        /* Storage type */
hmmio = mmioOpen ( NULL, &mmioInfo, MMIO_READ );

if(!hmmio)
{
fprintf(stderr,"Bad midi data to open...\n");
return -1;
}

midi_handles[i].hmmio = (ULONG)hmmio;
midi_handles[i].midimem = midimem;
midi_handles[i].loop = 0;
 
/* open MIDI device */
 
mop.pszElementName = (PSZ) hmmio;
mop.pszDeviceType = "Sequencer";
mop.pszAlias = NULL;
 
rc = mciSendCommand(
          0,                    /* We don't know the device yet. */
          MCI_OPEN,             /* MCI message                   */
          MCI_WAIT | MCI_OPEN_MMIO |
          MCI_OPEN_SHAREABLE,
          (PVOID) &mop,         /* Parameters for the message    */
          0 );                  /* Parameter for notify message  */

midi_handles[i].usDeviceID = mop.usDeviceID;

if(!mop.usDeviceID) // beef handle
{
/*
FILE *f;
fprintf(stderr,"Null device = %d bytes midi dumped\n",bufsize);
f=fopen("nulldump.mid","wb");
fwrite(midimem,bufsize,1,f);
fclose(f);
*/
}

//fprintf(stderr,"Midi %d open: device %d, hmmio %u\n",i,mop.usDeviceID,(ULONG)hmmio);

return i;
} 

void midi_play(int i,int looping)
{
USHORT usSeqDeviceID;
ULONG rc;
MCI_PLAY_PARMS mpp;

if(!midi_handles[i].midimem) return;

usSeqDeviceID = midi_handles[i].usDeviceID;
midi_handles[i].loop = looping;

/* play MIDI memory */
 
mpp.hwndCallback = hClient;
//mpp.ulFrom = 0;
//mpp.ulTo = 9000;

//fprintf(stderr,"Midi play %d, device %d\n",i,(ULONG)usDeviceID);

rc = mciSendCommand(
             usSeqDeviceID,         /* Device to play the data    */
             MCI_PLAY,              /* MCI message                */
             MCI_NOTIFY,            /* Flags for the MCI message  */
             (PVOID) &mpp,          /* Parameters for the message */
             (ULONG) i );                   /* Midi handle          */
}

void midi_replay(int i)
{
USHORT usSeqDeviceID;
ULONG rc;
MCI_PLAY_PARMS mpp;

if(!midi_handles[i].midimem) return;
if(!midi_handles[i].loop) return;

usSeqDeviceID = midi_handles[i].usDeviceID;

/* play MIDI memory */
 
mpp.hwndCallback = hClient;
mpp.ulFrom = 0;
//mpp.ulTo = 9000;

//fprintf(stderr,"Midi play %d, device %d\n",i,(ULONG)usDeviceID);

rc = mciSendCommand(
             usSeqDeviceID,         /* Device to play the data    */
             MCI_PLAY,              /* MCI message                */
             MCI_NOTIFY | MCI_FROM, /* Flags for the MCI message  */
             (PVOID) &mpp,          /* Parameters for the message */
             (ULONG) i );           /* Midi handle          */
}


void midi_pause(int i)
{ 
USHORT usSeqDeviceID;
MCI_GENERIC_PARMS    GenericParms;
ULONG rc;

if(!midi_handles[i].midimem) return;

usSeqDeviceID = midi_handles[i].usDeviceID;

/* stop device */
 
rc = mciSendCommand(
             usSeqDeviceID,            /* Device to play this          */
             MCI_PAUSE,             /* MCI message                  */
             MCI_WAIT,              /* Flags for the MCI message    */
             (PVOID) &GenericParms, /* Parameters for the message   */
             (PVOID) NULL );        /* Parameter for notify message */
}

void midi_resume(int i)
{ 
USHORT usSeqDeviceID;
MCI_GENERIC_PARMS    GenericParms;
ULONG rc;

if(!midi_handles[i].midimem) return;

usSeqDeviceID = midi_handles[i].usDeviceID;

/* stop device */
 
rc = mciSendCommand(
             usSeqDeviceID,         /* Device to play this          */
             MCI_RESUME,            /* MCI message                  */
             MCI_WAIT,              /* Flags for the MCI message    */
             (PVOID) &GenericParms, /* Parameters for the message   */
             (PVOID) NULL );        /* Parameter for notify message */
}

void midi_stop(int i)
{ 
USHORT usSeqDeviceID;
MCI_GENERIC_PARMS    GenericParms;
ULONG rc;

if(!midi_handles[i].midimem) return;

usSeqDeviceID = midi_handles[i].usDeviceID;

/* stop device */
 
rc = mciSendCommand(
             usSeqDeviceID,         /* Device to play this          */
             MCI_STOP,              /* MCI message                  */
             MCI_WAIT,              /* Flags for the MCI message    */
             (PVOID) &GenericParms, /* Parameters for the message   */
             (PVOID) NULL );        /* Parameter for notify message */
}

void midi_setvolume(int volume)
{
MCI_SEQ_SET_PARMS SeqSetParms;
ULONG rc;
memset( &SeqSetParms, '\0', sizeof( MCI_SEQ_SET_PARMS ) );
SeqSetParms.ulAudio = MCI_SET_AUDIO_ALL;
SeqSetParms.ulItem = 0;
SeqSetParms.ulLevel = (volume*100)/15;
rc = mciSendCommand( midi_handles[0].usDeviceID,
                     MCI_SET,
                     MCI_WAIT | MCI_SET_AUDIO | MCI_SET_VOLUME,
                     ( PVOID ) &SeqSetParms,
                     0 );
}

void midi_deregister(int i)
{
MCI_GENERIC_PARMS    GenericParms;
ULONG rc;
USHORT usSeqDeviceID;
if(!midi_handles[i].midimem) return;
free(midi_handles[i].midimem);

usSeqDeviceID = midi_handles[i].usDeviceID;

rc = mciSendCommand(
             usSeqDeviceID,            /* Device to play this          */
             MCI_STOP,              /* MCI message                  */
             MCI_WAIT,              /* Flags for the MCI message    */
             (PVOID) &GenericParms, /* Parameters for the message   */
             (PVOID) NULL );        /* Parameter for notify message */

rc = mciSendCommand(
             usSeqDeviceID,            /* Device to play this          */
             MCI_CLOSE,             /* MCI message                  */
             MCI_WAIT,              /* Flags for the MCI message    */
             (PVOID) &GenericParms, /* Parameters for the message   */
             (PVOID) NULL );        /* Parameter for notify message */

mmioClose((HMMIO)midi_handles[i].hmmio,0);

//fprintf(stderr,"Midi %d closed: device %d, hmmio %u\n",i,usDeviceID,
//        (HMMIO)midi_handles[i].hmmio);

midi_handles[i].midimem = (char*)NULL;
midi_handles[i].usDeviceID = 0;
midi_handles[i].loop = 0;

}