
#define DLLNAME                 "VIDEOPMI"
#define REQUEST_ENTRYPOINT      "VIDEOPMI32Request"
#define FAIL_LENGTH             256

typedef struct _FBINFO {
   ULONG     ulLength;          /*  Length of FBINFO data structure, in bytes. */
   ULONG     ulFlags;           /*  Specifies the capabilities supported. */
   ULONG     ulBPP;             /*  Screen bits per pel. */
   ULONG     ulXRes;            /*  Number of screen X pels. */
   ULONG     ulYRes;            /*  Number of screen Y pels. */
   ULONG     ulScanLineBytes;   /*  Number of bytes per scanline. */
   ULONG     fccColorEncoding;  /*  Screen color encoding. */
   ULONG     ulENDIVEDrivers;   /*  Number of EnDIVE drivers installed under GRADD architecture.  */
} FBINFO;

typedef FBINFO *PFBINFO;

typedef struct _APERTURE {  /* aperture */
      ULONG ulPhysAddr;       /* physical address */
      ULONG ulApertureSize;   /* 1 Meg, 4 Meg or 64k */
      ULONG ulScanLineSize;   /* this is >= the screen width */
      RECTL rctlScreen;       /* device independant co-ordinates */
} APERTURE;

typedef APERTURE FAR *PAPERTURE;
void APIENTRY DiveFullScreenInit (PAPERTURE pNewAperture,
                                  PFBINFO pNewFrameBuffer);

void APIENTRY DiveFullScreenTerm (void);

BOOL SwitchDiveMode (ULONG xRes, ULONG yRes, ULONG Bpp, PRGB2 prgb2Clut);
BOOL SetDisplayClut (PRGB2 prgb2Clut);
BOOL RestoreDiveMode ();
VOID FsLibInit (HMTX diveProtect);
