// Emacs style mode select   -*- C++ -*- 
//-----------------------------------------------------------------------------
//
// $Id:$
//
// Copyright (C) 1993-1996 by id Software, Inc.
//
// This source is available for distribution and/or modification
// only under the terms of the DOOM Source Code License as
// published by id Software. All rights reserved.
//
// The source is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// FITNESS FOR A PARTICULAR PURPOSE. See the DOOM Source Code License
// for more details.
//
// $Log:$
//
// DESCRIPTION:
//	Fixed point implementation.
//
//-----------------------------------------------------------------------------


static const char
rcsid[] = "$Id: m_bbox.c,v 1.1 1997/02/03 22:45:10 b1 Exp $";

#include <stdlib.h>

#include "doomtype.h"
#include "i_system.h"

#ifdef __GNUG__
#pragma implementation "m_fixed.h"
#endif
#include "m_fixed.h"




//__USE_C_FIXED__ or something.

int _imul( int a, int b );

#pragma aux _imul =       \ 
            "imul ecx"       \
            "shr eax, 16"    \
            "shl edx, 16"    \
            "or  eax,edx"    \
            parm [eax] [ecx] \
            modify [edx]     \
            value [eax];

fixed_t FixedMul( fixed_t a, fixed_t b )
{
#if 0
return _imul(a,b);
#endif

return (fixed_t)(((__int64)a*(__int64)b)>>16);
}

//   {
//   double _a,_b;
//    _a = (double)a;
//    _b = (double)b;
//    return (fixed_t)((_a * _b)/65536);
//    fixed_t	c;
//    _asm
//    {
//	mov eax, [a]
//	mov ecx, [b]
//	imul ecx
//	shr eax, 16
//	shl edx, 16
//	or eax, edx
//	mov [c], eax
//    }
//    return(c);
//
//   }



//
// FixedDiv, C version.
//

fixed_t
FixedDiv
( fixed_t	a,
  fixed_t	b )
{
    if ( (abs(a)>>14) >= abs(b))
	return (a^b)<0 ? MININT : MAXINT;
    return FixedDiv2 (a,b);
}



fixed_t
FixedDiv2
( fixed_t	a,
  fixed_t	b )
{

    //__int64 c;
    return (fixed_t)(((__int64)a<<16) / ((__int64)b));
#if 0

    double c;

    c = ((__int64)a * FRACUNIT)  / b;

    if (c >= 2147483648.0 || c < -2147483648.0)
	I_Error("FixedDiv: divide by zero");
    return (fixed_t) c;
#endif
}
