;
; OS/2 DOOM Assembly optimizations
;

.586
.MODEL flat,c

; Segment/section definition macros. 

.DATA?

; External variables:
EXTERN	_ds_xstep:NEAR;
EXTERN	_ds_ystep:NEAR;
EXTERN	_ds_colormap:NEAR;
EXTERN  _ds_source:NEAR;

EXTERN  _dc_source:NEAR;
EXTERN	_dc_colormap:NEAR;

EXTERN	_SCREENWIDTH:NEAR;

.DATA 
align 4

lastAddress DD 0
;EXTERN	_SCREENWIDTH:NEAR;

.CODE

PUBLIC	_DrawColumn8Loop

;    do 
;    {
;	// Re-map color indices from wall texture column
;	//  using a lighting/special effects LUT.
;	*dest = dc_colormap[dc_source[(frac>>FRACBITS)&127]];
;	
;	dest += SCREENWIDTH; 
;	frac += fracstep;
;	
;    } while (count--); 

;void DrawColumn8Loop(fixed_t frac, fixed_t fracstep, int count, byte *dest);
_DrawColumn8Loop:

	push	ebp
	push	edi
	push	esi
	push	ebx

	mov	ecx,[esp+24]	; count    28+4
        push    edx

	mov	eax,[esp+20+4]	; frac     20+4
	mov	edi,[esp+32+4]	; dest     32+4

	mov	ebx,[esp+28+4]	; fracstep 24+4
        push    ebx

        mov     ebp,[_dc_colormap]
        xor     edx,edx

        mov     esi,[_dc_source]
        inc     ecx

        mov     ebx,[_SCREENWIDTH] ; copy SCREENWIDTH into stack
        push    ebx

	align 4

drawc8l:mov     ebx,eax
        dec     ecx

        shr     ebx,16
        add     eax,[esp+4] ; frac+=fracbits

        and     ebx,127
	mov     dl,[esi+ebx] ; dl = dc_source[frac>>16]

        mov     bl,[ebp+edx] ; bl = dc_colormap[dl]
        mov     [edi],bl     ; *dest = bl

        add     edi,[esp]    ; [_SCREENWIDTH] ; dest +=SCREENWIDTH
	test	ecx,ecx

	jnz drawc8l

skipsec:add     esp,8 ; clear stack

        pop     edx
	pop	ebx
	pop	esi
	pop	edi
	pop	ebp

	ret




;*----------------------------------------------------------------------
;*
;* DrawSpan8Loop Written by Petteri Kangaslampi <pekangas@sci.fi>
;* and Donated to the public domain.
;*
;*----------------------------------------------------------------------

PUBLIC	_DrawSpan8Loop

; pushd xfrac
; pushd yfrac
; pushd count
; pushd dest ; = 16
; call _drawspan8loop ; = 20
; _drawspan8loop:
; pushd epb
; pushd edi
; pushd esi
; pushd ebx ; + 16 = 36
; dest = 32
; count = 28
; yfrac = 24
; xfrac = 20
;
;


;void DrawSpan8Loop(fixed_t xfrac, fixed_t yfrac, int count, byte *dest);

_DrawSpan8Loop:

	push	ebp
	push	edi
	push	esi
	push	ebx

	mov	eax,[esp+28]	; count 28
	mov	ebx,[esp+20]	; xfrac 20
s0:	
	mov	edi,[esp+32]	; dest  32
	add	eax,edi
	mov	ecx,[esp+24]	; yfrac 24
	mov	[lastAddress],eax
	
	mov	ebp,ebx
	mov	edx,ecx
	and	ebp,65536*63
	shr	edx,10

	shr	ebp,16
	xor	eax,eax
	nop

ds8loo:	and	edx,64*63
	mov	esi,[_ds_source]

	or	ebp,edx
	mov	edx,[_ds_xstep]

	add	ebx,edx
	mov	edx,[_ds_ystep]

	mov	al,[esi+ebp]
	mov	esi,[_ds_colormap]

	add	ecx,edx
	mov	ebp,ebx

	mov	edx,ecx
	mov	al,[esi+eax]

	shr	edx,10
	mov	[edi],al

	shr	ebp,16
	and	edx,64*63

	and	ebp,63
	mov	esi,[_ds_source]

	or	ebp,edx
	mov	edx,[_ds_xstep]

	add	ebx,edx
	mov	edx,[_ds_ystep]

	mov	al,[esi+ebp]
	mov	esi,[_ds_colormap]

	add	ecx,edx
	mov	ebp,ebx

	mov	edx,ecx
	mov	al,[esi+eax]

	shr	edx,10
s1:	mov	[edi+1],al

	shr	ebp,16
	mov	esi,[lastAddress]

	and	ebp,63
s2:	add	edi,2

	cmp	edi,esi
	jbe	ds8loo

	pop	ebx
	pop	esi
	pop	edi
	pop	ebp

	ret

END